;A simple program demonstrate basic simulator usage.
;It is similar to ex2-subroutines, but uses conditional
;branches.

;The only instructions used are:
;   adda, bcc, clra, inca, jmp, jsr, ldaa, ldab,
;   rts, staa and stab.
;Only Inherent, Relative and Extended addressing modes are used.
; By convention, this segment begins at 0x6000.
              org $6000   ;ROMable segment
main:
              jsr init

forever:
              jsr calculate
              jmp forever
init:
              clra
              staa firstNumber
              staa wrong  ;initialize "wrong" as "false"
              inca
              staa secondNumber
              rts

calculate:
              ldaa secondNumber
              staa oldSecondNumber
              ldaa firstNumber
              adda secondNumber
              bcc ok
              ldab #$FF
              stab wrong
ok:
              staa secondNumber
              ldaa oldSecondNumber
              staa firstNumber
              rts

; Modifiable data --  starts (by convention) at 0x7000
                org $7000
firstNumber     rmb 1  
secondNumber    rmb 1
wrong           rmb 1 ;contains 0 if correct, $FF if wrong
oldSecondNumber rmb 1

              end
