; A simple program to test/deonstrate adc module.
; Author: Ken Clowes
; Date: September 21, 2002

; This program implements:
;    init()   //Set all results to 0
;    while(1) {
;       //configure for single conversion of first 4 channels
;       //wait for completion
;       //save results in results[0..3]
;       //configure for single conversion of second 4 channels
;       //wait for completion
;       //save results in results[4..7]
;   }
;

ADCTL equ $1030     ;address of ADC Control register
ADR1  equ ADCTL+1   ;address of first result register
ADR2  equ ADCTL+2   ;address of second result register
ADR3  equ ADCTL+3   ;address of third result register
ADR4  equ ADCTL+4   ;address of fourth result register

SINGLE_CONVERSION equ %00010000

;ROMable segment (memory constants + program)
      org $6000
main:
	jsr init

forever:
        ;initiate a conversion on first 4 channels
        ldaa #SINGLE_CONVERSION
        staa ADCTL
        jsr waitCCF

        ;Save first 4 channels
        ldaa ADR1
        staa results

        ldaa ADR2
        staa results+1

        ldaa ADR3
        staa results+2

        ldaa ADR4
        staa results+3


        ;Now do other 4 channels

        ldaa #SINGLE_CONVERSION+4
        staa ADCTL
        jsr waitCCF

        ;Save higher 4 channels
        ldaa ADR1
        staa results+4

        ldaa ADR2
        staa results+5

        ldaa ADR3
        staa results+6

        ldaa ADR4
        staa results+7

        ;keep on trucking....
        bra forever

init:
        clr results
        clr results+1
        clr results+2
        clr results+3
        clr results+4
        clr results+5
        clr results+6
        clr results+7
        rts

waitCCF:
         tst ADCTL
         bpl waitCCF
         rts


;  RAM segment
         org $7000
results  rmb 8  ;8 channels (contains digital values of each channel)
         end
